% This is samplepaper.tex, a sample chapter demonstrating the
% LLNCS macro package for Springer Computer Science proceedings;
% Version 2.20 of 2017/10/04
%
\documentclass[runningheads]{llncs}
\setcounter{tocdepth}{2}
\setcounter{secnumdepth}{3}% Number up to \subsubsection
        \makeatletter
        \renewcommand*\l@author[2]{}
        \renewcommand*\l@title[2]{}
        \makeatletter
%
\usepackage{graphicx}
% Used for displaying a sample figure. If possible, figure files should
% be included in EPS format.
%
% If you use the hyperref package, please uncomment the following line
% to display URLs in blue roman font according to Springer's eBook style:
% \renewcommand\UrlFont{\color{blue}\rmfamily}

\begin{document}


\title{Project Initiation Document}
%
%\titlerunning{Abbreviated paper title}
% If the paper title is too long for the running head, you can set
% an abbreviated paper title here
%
\author{  Alain Mahieu\and
Hieu Le \and
Jeongkyeong Park \and Liangkun He \and  Tomasz Karg}

\institute{RWTH Aachen University, Aachen NRW 52064, Germany }

\maketitle              % typeset the header of the contribution

\tableofcontents
\newpage


\section{Introduction}
We will develop a software using conformance checking technique for FCC Bank, which decided to apply process mining technique to their business process management.\\
The remaining document is organized as follows. In section 2 we introduce our business case for the product. We explain the benefits and how these benefits will be measured. In section 3 we provide feasibility of our project in both theoretical and technical point of view. Section 4 describes the time frame of our project. Section 5 provides an overview of the tools that we use. Section 6 gives an introduction of our team members and the roles that assign to us. Section 7 provides a sprint review.

\section{Business Case}

\subsection{Client}

Our client is the FCC Bank, which wants to utilize the process mining technique in their business process management. Banking industry is a complex industry where there are numerous regulations that need to be strictly adhered, otherwise, legal penalties may be imposed. Not only the external regulations but also the internal rules must be observed, which can lead to internal disruption if they are violated. Thus, to ensure the compliance, every process and every process execution must be examined if it is still within certain boundaries. In the following paragraphs we will provide several exemplars for using \emph{Conformance Checking} in compliance checking so that the company can enhance the performance of process management. 

\subsection{Example 1: Work flow in company}
Even a well-designed organization entails risks that it does not proceed according to plan. Suppose FCC Bank made an agreement with A1 GmbH on giving a debt but the A1 GmbH could not receive the money yet and it eventually caused consequences. Applying the \emph{Conformance Checking} by replaying the event logs on the process model of the company, the problem can be showed timely (agreement made but no money delivery) and also the reason behind it can be revealed. Our product will help company to be signaled timely when any process is not executed as planned, thus, the company can have required actions in time to reduce the unfortunate consequences as much as possible. 

\subsection{Example 2: Extend the business}
Suppose FCC Bank wants to extend their business in country A, where there are several minor different regulations and institutions. Because of the huge amount of costs and expenses to build a new model of organization that complies these new rules, FCC Bank can apply \emph{Conformance Checking} to discover the "weak spot" in their process model when the new rules are applied and therefore the efficient changes can be made in time. Our product will help company quickly notice the unsuitable processes when the regulations are modified and eventually make the right changes in their process model. 



\section{Feasibility Study}
\subsection{Theoretical Feasibility}
In order to understand what a feasibility study is it is helpful to know the definition of feasible.
The term “feasible” describes an action or event that is likely, probably or possible to happen or achieve.
Therefore a feasibility study is an amount of prepared and asked questions in combination with actions that are performed to determine whether an idea is likely to work, or not.\\
The approach used in our company is footprint-based conformance checking. That means we use data in form of event logs and Process models (in our case Process Trees) provided by our customer, the FCC bank, to determine the conformance between logs and models. This type of analysis is convenient in several use cases. First there is compliance checking, that means comparing cases with each other in terms of general behavior, in other words: searching for deviants e.g. for auditing (examining whether processes meet the required standards) or fraud detection. Next there is the evaluation of process discovery results. Comparing process models to event logs which they were built from or completely new logs to test how they will perform in the future. The evaluation is done in respect to four dimensions: fitness, generalization, precision and simplicity. Last there is conformance to specification which means to meet any requirements defined for the product. Every customer should receive the service they are paying for.\\
All these cases are represented in this project. One of the main tasks of the FCC Bank is to transfer money,which is a main reason why she is prone to fraud. Also, their clients want to receive what was promised to them. As future oriented work order it is necessary to compare different models on different log samples to get optimized and efficient processes that work on unknown data logs, like logs from the future. To ensure fraud prevention, client requirements and future orientated models our approach is the right choice and can be implemented by using Python and the PM4Py process mining package. With the theoretical knowledge about comparing and interpreting footprint matrices from logs and models and tools provided by PM4Py we create a program that meets all the requirements.
\subsection{Technical Feasibility}
Every company has internal regulations and has to meet statutory or industry-specific regulations. Especially banks are a very strongly regulated industry and therefore it is very important that business processes run according to those specifications to avoid contractual, monetary or legal penalties. 

The goal of our project is to provide a tool for the FCC Bank that will help them monitor their business processes and indicate deviations. In order to do this we will implement a web service that takes a process model in form of a process tree and an event log as input and produces footprints of both with highlighted deviations as output.

To realize our project we will make use of the PM4Py library which is being developed and maintained by the Frauenhofer Institute for Applied Information Technology (FIT). The library provides functionalities to handle both process trees and event logs such as input, generation and visualization. Due to this support PM4Py is our choice for the back-end development. 
For setting up the web interface we will use the Flask Framework. Flask is a lightweight WSGI web application framework which has become one of the most popular python web application frameworks. It comes with functionalities such as Error Handling or Testing and provides optional extensions. In addition Flask can be integrated into PyCharm which we will be using for development. For this reasons Flask is our choice for the frontend-development.
PM4Py and Flask are both implemented using Python which is a general purpose programming language. The Use Case \ref{ForeCastWatch} shows the applicability of python to be used as the programming language for our project.


\subsection{Use Case: ForeCastWatch} \label{ForeCastWatch}
ForeCastWatch is a service of Intellovations for rating the accuracy of weather reports from companies. It collects 36.000 weather forecasts per day for over 800 U.S. cities to compare it to actual climatological data. It helps meteorologists to improve their weather forecast and consumers to better understand the accuracy of weather forecasts.
ForeCastWatch is a 100\% Python implementation from the front-end to the back-end and consists of four major components: An input process for acquiring forecasts, an input process for acquiring measured climatological data, the data aggregation engine and the web application framework. Python was initially chosen to work with because of its many libraries for working with data. 
Currently the product contains over 5.000 lines of code most of which implement the high-level functionalities of the application while the details are taken care of by the standard libraries for python. During development Python turned out to be much more flexible and effective in evolving prototypes to production code than other high level general purpose programming languages like Java or C++ while not sacrificing capabilities. 

\section{Time Frame}
We have decided to create the following Gantt chart to present our plans : \\

\begin{figure}[h]

\centering
\includegraphics[width=0.7\textwidth]{TimeFrame}

\label{TimeFrame}
\end{figure}

We want to have enough time to think about the tasks and to discuss each other before starting work. This is also to forestall potential mistakes coming from the last-minute work processing because everyone has a different schedule during the semester. 
For every group of tasks (Project Initiation, Requirements Analysis and every Sprint) we plan to hold a meeting to analyze what we have to do and distribute the tasks that each person wants to do or could do. 
We have about one week to write code and document the process for each Sprint. Before submission the project outcome could be improved through a peer review and discussion of each task that we take. 
Because this time frame is just roughly set, it may be changed slightly depending on the difficulty of the task and the time required to resolve it.

\section{Overview of Tools}
\subsection{Discord}
	Especially in hard times like this we need to come up with creative ideas to fulfill our tasks. Normally we would use the opportunity of meeting each other after the internship briefing or between courses. Since we cannot just come together for a talk in the Informatikzentrum Library, we decided to use Discord as speech communication tool. After obtaining and using an invitational link, members of our group gain permanent permission to join and leave voice servers within a few clicks whenever they want. In combination with the intuitive and user-friendly interface Discord is a fast and easy to handle tool to create meetings whether planned or not. Last but not least it is free to use.
\subsection{Trello}
Trello will be our main tool to organize our work. It provides functionalities that will greatly ease our organization. We can define tasks with or without subtasks making it possible to track our progress at any moment of developing. Furthermore we can assign tasks to specific persons making it easier to keep track who is working on what parts. It comes with functionalities like color tags to specify types of tasks or indicating problems. We can also set deadlines to see what needs to be finished at a certain time. Overall this tool will make organizing our teamwork and communication much easier. 

\subsection{PyCharm}
PyCharm is an integrated development environment developed by the Czech company JetBrains. It is specially used for language Python, which is the main language we use in our product. PyCharm supports multiple scientific package including PM4Py library and also offers great framework-specific support for web development frameworks such as Flask, which are the tools we will use in our product. In general, PyCharm is an user-friendly IDE for writing code in Python.

\subsection{GitLab}
We decided to use GitLab as our version control tool. GitLab is a web based DevOps tool that provides a Git-repository manager providing issue-tracking, wiki and continuous integration pipeline features. We keep our code in a centralized repository, where each one of us can contribute our works and easily integrate it with others. It is intuitive for a team to use branching to fix code issues and to develop new features. Moreover GitLab provides free unlimited private repositories which is great for industry and student team like us.

\section{Team Members}

\subsection{Personal Descriptions}
  \subsubsection{Alain Mahieu}\
  \\
  I am a Bachelors computer science student at RWTH Aachen. My interests lie in Artificial Intelligence and Data Science making process mining as an applied field of both an interesting topic for me. My first programming experiences started with Java and C followed by Python later on. Though I have written several minor programs in each of these languages my practical experience in bigger projects like this combined with working together with several programmers is still limited. This project will be good to change that. I am familiar with the theory behind this project although I never implemented anything in this field. I enjoy learning new things and figure out how to get things running. I think this project will be a good opportunity to improve both my practical programming skills and teamwork.
  \subsubsection{Hieu Le}\
  \\
  I am a computer science student in the 6th semester at the RWTH Aachen University. I find the field of Process Mining very interesting and promising, thus, I participate in this course to extend my knowledge in this area. My interest in this field is enlarged through the successful attendant in the Proseminar Data Preprocessing and currently attendant in the course Business Process Intelligent. My main weakness is lacking of practical programming, therefore, by taking part in this course, I want to improve this weakness and increase my Python proficiency.
  \subsubsection{Jeongkyeong Park}\
  \\
  I am a computer science student at the RWTH Aachen University. I got interested in this field through a friend who works as a student assistant (Hiwi) at an Institute in which mainly dealing with process and data mining. Then I am currently attending the course Business Process Intelligence and I got this opportunity to be able to increase my interest in this field and gather more practical experience.
  
  \subsubsection{Liangkun He}\
\\  
   I am studying computer science at RWTH Aachen University. I am interested in Artificial Intelligence. However, AI is considered a wide field and I hadn't found my specific theme. In the previous semester I finished my proseminar "Data Preprocessing" in the chair of Process and Data Science, in which I discovered that process mining can be applied to the area of AI. I have programming experience in the language C, but still no experience in programming with Python. So I decided to attend this lab to develop my programming skill with Python as well as to improve my ability to work with others as a team.
  
  \subsubsection{Tomasz Karg}\
  \\
  I am studying computer science at the RWTH Aachen university. My interest is more on the theoretical side of the spectrum. Understanding why algorithms work in a certain way is one thing I enjoy about computer science. Analyzing algorithms is therefore one of my favorite tasks, especially because I like to incorporate my mathematical understanding. I choose this internship due to the interesting topic of Data science and Process Mining. Using some simple algorithm to achieve visible results with enormous impact for the real world in regards of making it more efficient place, is fascinating. For me Python declares as beginner friendly programming language, which is a great opportunity to improve my coding abilities, because they are on a low intermediate level. In Addition, learning and working with useful tools like Gitlab is practical. 
  
\subsection{Roles}

\subsubsection{Official communication/product owner: Hieu}\
\\
Hieu is in charge of establishing a communicating channel between team members and with the teaching assistant.
\subsubsection{Software experts: Hieu, Liangkun}\
\\
They will be responsible for the applying of Python, Flask and the libraries we will be using in our product.
 \subsubsection{Front end developer: Liangkun}\
\\
Liangkun will be responsible for front end development, which converting data to a readable web interface that clients can view and interact with.
\subsubsection{Quality management of tests: Jeongkyeong}\
\\
Jeongkyeong is in charge of ensuring the quality of the tests we perform during the project. These tests would improve the processes.
\subsubsection{Data management: Jeongkyeong}\
\\
Jeongkyeong will be responsible for managing all of the databases we use.
\subsubsection{Scrum Master: Alain}\
\\
Alain will be our Scrum Master. He will be taking care of the general organizational aspects of the project like assigning tasks or managing the Trello board.
\subsubsection{Theoretical experts/Architectures: Tomasz, Alain}\
\\
Tomasz and Alain will be our theoretical experts. This task includes understanding the theoretical aspects behind our project and define an architecture of our implementation.  

\section{Sprint Review}

\subsection{Alain Mahieu}
"At first it was difficult to get what should be the outcome of this phase. Getting an example on what this phase is supposed to produce was definitely helpful. I think our team had a rough time on getting started until we made a meeting to discuss everything. Therefore I think that we should start every phase with a team meeting. After we agreed on the direction we wanted to go I think we did a decent job on assigning the tasks. Besides I think we may have run into time problems due to getting started too late. This problem should be easily resolved by starting the phases with a team meeting."

\subsection{Hieu Le}
"At the beginning of this phase I was a bit confused because this kind of task and also how we cooperate to do it were new to me. But after discussing it with our teammates and splitting the tasks, it went really well and I think we did a great job. Hope our team will carry on this great work in the next sprints and finish the course successfully."

\subsection{Jeongkyeong Park}
"We had no idea what to do. From the first meeting where someone came up with an idea and we discussed it, it seems that we found out what we have to do in the next steps. I also thought I should study harder to be a valuable part of the team. The start is very small, but in the end I hope to achieve what we have planned."

\subsection{Liangkun He}
"At first it was difficult for me to figure out what kind of business case we should develop. After we successfully arranged the meeting with the team it became clear which direction we should go and how we should do our task. We quickly agreed on the business case and then distributed tasks. So I say we had a successful phase. In the following phases I think we should start arranging the meeting earlier so that we will not run into a time problem. I have faith in our team that we will accomplish the project successfully."

\subsection{Tomasz Karg}
“I like the idea of starting an internship with a project initiation document as first submission. It gives the group the opportunity to meet and discuss general procedures. It is like a test run, in which we can see where there are some issues so we can fix them subsequently. Due to the current situation, we had to get a little creative, but thanks to the two-week deadline we had no major difficulties. The task itself is generally a good idea to get a firm start into the topic of footprint conformance checking, when you can interpret it correctly. For me the creation of a businesses case, usage of use cases, and feasibility studies had no clear borderline. It was difficult to distinguish whether tasks like “From theoretical point of view: refer to documentation/papers” were meant for our fictional company or a general formal definition, or another use case which we could simply search for on the internet. Because the tasks had too much leeway, I didn't know what exactly was expected of me. For me it is rough to work on such imprecise tasks. “

%
% ---- Bibliography ----
%
% Examplars of Bibliograhy

\begin{thebibliography}{10}
%\bibitem{ref_article1}
%Author, F.: Article title. Journal \textbf{2}(5), 99--110 (2016)
%
%\bibitem{ref_lncs1}
%Author, F., Author, S.: Title of a proceedings paper. In: Editor,
%F., Editor, S. (eds.) CONFERENCE 2016, LNCS, vol. 9999, pp. 1--13.
%Springer, Heidelberg (2016). \doi{10.10007/1234567890}
%
%\bibitem{ref_book1}
%Author, F., Author, S., Author, T.: Book title. 2nd edn. Publisher,
%Location (1999)
%
%\bibitem{ref_proc1}
%Author, A.-B.: Contribution title. In: 9th International Proceedings
%on Proceedings, pp. 1--2. Publisher, Location (2010)
%
%\bibitem{ref_url1}
%LNCS Homepage, \url{http://www.springer.com/lncs}. Last accessed 4
%Oct 2017
\bibitem{ref_ForeCastWatch}
ForeCastWatch Homepage, \url{http://www.python.org/about/success/forecastwatch}. Last accessed May 20, 2020
\bibitem{ref_ProcessMining}
W. van der Aalst: Process Mining: Data Science in Action. Springer Verlag, Berlin (2016)
\end{thebibliography}

\end{document}